#include <bits/stdc++.h>

using namespace std;
using ll = long long;
ll n, m, k;
vector<ll> a[300000];
ll visited[300000];

void dfs(ll p, ll h) {
    visited[p] = 1;
    if (h > 0) {
        for (ll i = 0; i < a[p].size(); i++) {
            dfs(a[p][i], h - 1);
        }
    }
}

int main() {
    // freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m >> k;
    while (m--) {
        ll p, q;
        cin >> p >> q;
        a[p].push_back(q);
        a[q].push_back(p);
    }
    for (ll i = 1; i <= n; i++) {
        visited[i] = 0;
    }
    while (k--) {
        ll p, h;
        cin >> p >> h;
        dfs(p, h);
    }
    ll ans = 0;
    for (ll i = 1; i <= n; i++) {
        if (visited[i] == 1) {
            ans++;
        }
    }
    cout << ans << '\n';
    for (ll i = 1; i <= n; i++) {
        if (visited[i] == 1) {
            cout << i << " ";
        }
    }
    return 0;
}
